echo off
mode con cols=100 lines=50
echo ***************************************************
echo .
echo This batch file creates shortcuts for SpecWeb
echo and installs necessary runtimes.
echo If you should wish to uninstall SpecWeb
echo just delete the shortcuts and the download
echo directory. The Microsoft and Intel runtimes can
echo be uninstalled from your control pannel.
echo .
echo ***************************************************
SET Version=Unknown

VER | FINDSTR /IL "5.0" > NUL
IF %ERRORLEVEL% EQU 0 SET Version=1

VER | FINDSTR /IL "5.1." > NUL
IF %ERRORLEVEL% EQU 0 SET Version=1

VER | FINDSTR /IL "5.2." > NUL
IF %ERRORLEVEL% EQU 0 SET Version=1

VER | FINDSTR /IL "6.0." > NUL
IF %ERRORLEVEL% EQU 0 SET Version=2

VER | FINDSTR /IL "6.1." > NUL
IF %ERRORLEVEL% EQU 0 SET Version=2 
set A=%CD%
if %Version%==1 set A=%cd%\bin

:Check_Runtime_2010
REG QUERY "HKEY_LOCAL_MACHINE\SOFTWARE\Classes\Installer\Products\1D5E3C0FEDA1E123187686FED06E995A" /v ProductName > NUL 2>&1 || goto Install_Runtime_2010
goto Check_Runtime_2019

:Install_Runtime_2010
echo ***************************************************
echo .
echo Installing C++ Runtime 2010
echo .
echo Please follow instructions to install
echo .
vcredist_x86_100.exe"
echo .
echo ***************************************************


:Check_Runtime_2019
REG QUERY "HKEY_LOCAL_MACHINE\SOFTWARE\WOW6432Node\Microsoft\VisualStudio\14.0\VC\Runtimes\X86" /v Version > NUL 2>&1 || goto Install_Runtime_2019
goto Check_Intel_Runtime

:Install_Runtime_2019
echo ***************************************************
echo .
echo Installing C++ Runtime 2015, 2017, 2019
echo .
echo Please follow instructions to install
echo .
vc_redist.x86.exe
echo .
echo ***************************************************


:Check_Intel_Runtime
REG QUERY "HKEY_LOCAL_MACHINE\SOFTWARE\Classes\Installer\Products\167109D920AA3564086DCBCE5D2DB7AA\SourceList" /v PackageName > NUL 2>&1 || goto Install_Intel_Runtime
goto Install_SPEC

:Install_Intel_Runtime
echo ***************************************************
echo .
echo Intalling Intel C++ Runtime
echo .
echo Please follow instructions to install
echo .
".\ww_icl_redist_msi_2019.5.281\ww_icl_redist_ia32_2019.5.281.msi""
echo ***************************************************


:Install_SPEC
echo ***************************************************
echo .
echo Creating Shotcuts for SpecWeb on desktop
echo .
set desktop="unknown"
FOR /F "tokens=* USEBACKQ" %%F IN (`powershell -noninteractive -command [Environment]::GetFolderPath^('Desktop'^)`) DO (   SET desktop=%%F)
echo in %desktop%
echo .
echo ***************************************************
"%A%\shortcut.exe" /f:"%desktop%\SpecWeb 2.2.lnk" /a:c /t:"%A%\SpecWeb.exe" /P:"-A" /W:"%A%"
"%A%\shortcut.exe" /f:"%desktop%\SpecWeb 2.2 Play.lnk" /a:c /t:"%A%\SpecWeb.exe" /P:"-P1" /W:"%A%"
"%A%\shortcut.exe" /f:"%desktop%\SpecWeb 2.2 Play Remote.lnk" /a:c /t:"%A%\SpecWeb.exe" /P:"-P1 -pnone" /W:"%A%"
echo .
echo Setting Compatibility Mode for SpecWeb
reg add "HKEY_CURRENT_USER\Software\Microsoft\Windows NT\CurrentVersion\AppCompatFlags\Layers" /v "%A%\SpecWeb.exe" /t REG_SZ /d "~ WIN8RTM" /f
:FINAL
echo ***************************************************
echo .
echo Installation is COMPLETE.
echo .
echo ***************************************************
start "" SpecWebPostInstall.html

:leave
pause